open Syntax
    
(* Definitional interpreter for λ-calculus with 4 delimited continuation operations : eval1 *)

(* Value : プログラムの実行結果を表す型 *)
type v = VNum of int
       | VFun of (v -> c -> t -> m -> v)
       | VContS of c * t
       | VContC of c * t

and c = v -> t -> m -> v

and t = TNil | Trail of c

and m = MNil | MCons of (c * t) * m

(* プログラムの実行結果を文字列にする関数 *)
(* to_string : v -> string *)
let rec to_string value = match value with
    VNum (n) -> string_of_int n
  | VFun (_) -> "<VFun>"
  | VContS (_) -> "<VContS>"
  | VContC (_) -> "<VContC>"

(* プログラムの実行結果をプリントする関数 *)
(* Value.print : v -> unit *)
let print exp =
  let str = to_string exp in
  print_string str
