(* Interpreter using combinators factored as instructions : eval8 *)

(* Value : プログラムの実行結果を表す型 *)
type v = VNum of int
       | VFun of (s -> c -> t -> m -> v) 
       | VContS of c * s * t
       | VContC of c * s * t
       | VEnv of v list
       | VK of c

and c = s -> t -> m -> v

and s = SNil
      | SCons of v * s
      | SAppend of s * s

and t = TNil | Trail of c * s

and m = MNil
      | MCons of (c * s * t) * m

type i = s -> c -> t -> m -> v

(* プログラムの実行結果を文字列にする関数 *)
(* to_string : v -> string *)
let rec to_string value = match value with
    VNum (n) -> string_of_int n
  | VFun (_) -> "<VFun>"
  | VContS (_) -> "<VContS>"
  | VContC (_) -> "<VContC>"
  | VEnv (_) -> "<VEnv>"
  | VK (_) -> "<VK>"

(* プログラムの実行結果をプリントする関数 *)
(* Value.print : v -> unit *)
let print exp =
  let str = to_string exp in
  print_string str
